/******************************************************
*  CT2D Client main   2013.Dec.15,   NormalMode()     *
*******************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "ct2d.h"
/************************/
/** External Functions **/
/************************/
#include "Dataio.h"
#include "Basic.h"
#include "solveSTATIC.h"
#include "Cpu.h"
/**********************
	CT2D entry
***********************/
int ct2d_main(
	char inpfile[],
	char outfile[],
	char logfile[],
	char vtffile[],
	char pltfile[],
	char matfile[],  // 2014apr04
	CT2D* ct2d)
{
	FILE  *fp_inp;
	FILE  *fp_out;
	FILE  *fp_log;
	FILE  *fp_vtf;
	FILE  *fp_plt;
	FILE  *fp_mat;  // 2014apr04
	float cputime[20]; /*** CPU counter ***/
/** Starting ***/
	cputime[0]=cpu_count();
/***** Log file *****/
	if( !strcmp(logfile,"") ) {
		fp_log=stdout;
	}else{
		if( (fp_log=fopen(logfile,"w")) == NULL){
			printf("log file cannot be opened!\n");
			return 1;
		}
	}
/***** Inp file *****/
	if( (fp_inp=fopen(inpfile,"r")) == NULL){
		fprintf(fp_log,"input file cannot be opened!\n");
		return 1;
	}
/***** Out file *****/
	if( (fp_out=fopen(outfile,"w")) == NULL){
		fprintf(fp_log,"output file cannot be opened!\n");
		return 1;
	}
/***** Vtf file *****/
	if( (fp_vtf=fopen(vtffile,"w")) == NULL){
		fprintf(fp_log,"vtf file cannot be opened!\n");
		return 1;
	}
/***** Plt file *****/
	if( (fp_plt=fopen(pltfile,"w")) == NULL){
		fprintf(fp_log,"plt file cannot be opened!\n");
		return 1;
	}
/***** Mat file *****/
	if( (fp_mat=fopen(matfile,"w")) == NULL){                // 2014apr04
		fprintf(fp_log,"mat file cannot be opened!\n");  // 2014apr04
		return 1;                                        // 2014apr04
	}
	printf("%s   matfile open\n",matfile);
/*** Message ***/
	fprintf(fp_log,"### STARTED!\n");
/** read input data **/
	read_data(fp_inp,fp_log,ct2d);
	fclose(fp_inp);
/** input data echo **/
	input_echo( fp_out, fp_log,ct2d);
	cputime[1]=cpu_count();
/** create dof table ***/
	printf("before create_doftab\n");
	create_doftab( fp_out, fp_log, ct2d);
/** create constList ***/
	create_constList( fp_out, fp_log, ct2d);
	cputime[2]=cpu_count();
/******************************/
/**** 2D Truss Analysis *******/
/******************************/
//	solveSTATIC( fp_out, fp_log, fp_vtf, fp_plt, ct2d);
	NormalMode( fp_out, fp_log, fp_vtf, fp_plt, fp_mat, ct2d); // 2014apr04
	cputime[3]=cpu_count();
	fclose( fp_vtf );
	fclose( fp_mat );                                          // 2014apr04
/****************************** 
  List of cpu time
*******************************/
	fprintf(fp_out,"#### CPU time informations (sec)\n");
	fprintf(fp_out," Input Data Phase..................%.2f\n",cputime[1]-cputime[0]);
	fprintf(fp_out," Preprocessing for Solver..........%.2f\n",cputime[2]-cputime[1]);
	fprintf(fp_out," Solver Process....................%.2f\n",cputime[3]-cputime[2]);
	fprintf(fp_out,"---------------------------------------\n"); 
	fprintf(fp_out," total.............................%.2f\n",cputime[3]-cputime[0]);
	fprintf(fp_log,"#### CPU time informations (sec)\n");
	fprintf(fp_log," Input Data Phase..................%.2f\n",cputime[1]-cputime[0]);
	fprintf(fp_log," Preprocessing for Solver..........%.2f\n",cputime[2]-cputime[1]);
	fprintf(fp_log," Solver Process....................%.2f\n",cputime[3]-cputime[2]);
	fprintf(fp_log,"---------------------------------------\n"); 
	fprintf(fp_log," total.............................%.2f\n",cputime[3]-cputime[0]); 
	fprintf(fp_log,"### FINISHED!\n");
	fclose(fp_out);
	fclose(fp_log);
	return 0;
}
