#include <stdio.h>
#include <math.h>
//#include "LIButility.h"  // vectorR()
#define MAX(x,y) (x>y?x:y)
#define	DEBUG	1
#define pi 3.14159265358979

void genamat(double * mvec, double *b, double *a, int n, int nb, FILE *fp_mat){
   int i, j, j1;
   double scal;

   printf("genamat%d,%d\n",n,nb);

   for(j = 0; j < n ; j++){
      for(i = 0; i < n; i++){ a[j*n+i]=0;} 
   }

   for(j = 1; j <= n ; j++){
      j1=MAX(j-nb+1,1);
      for(i=j1; i<=j; i++){
         a[(j-1)*n+i-1]=b[j*nb-j+i-1];   /*  LOWER 0  (ct2d.h), i.e., upper  */
//       printf("A(%d,%d)=%e from %d\n",i,j,a[(j-1)*n+i-1],j*nb-j+i-1);
      }
   }
/*** fill lower portion by transpose   ***/
   for(j = 0; j < n ; j++){
      for(i=j+1; i<n; i++){
         a[j*n+i] = a[i*n+j];
      }
   }
/*** show matrix ***/
#if DEBUG
   printf("### matrix ####\n");
   for(j = 0; j < n ; j++){
      for(i=0; i<n; i++){
         if(a[j*n+i] != 0) printf("A(%d,%d)=%e\n",i,j,a[j*n+i]);
      }
   }
#endif  
/*** file output n and K matrix  ***/
   fprintf(fp_mat,"%d\n",n);                     //2014may06
   for(i=0; i<n; i++){                           //2014may06
      for (j=0; j<n; j++){                       //2014may06
//       fprintf(fp_mat,"%25.17le",a[n*j+i]);    //2014may06
         if(a[n*j+i] != 0){;  
            fprintf(fp_mat," %d",i);              //2014oct21
            fprintf(fp_mat," %d",j);              //2014oct21
            fprintf(fp_mat,"%25.17le\n",a[n*j+i]); //2014oct21
	 }
      }                                          //2014may06
//    fprintf(fp_mat,"\n");                      //2014may06
   }                                             //2014may06
/*** file output M matrix  ***/
   for (j=0; j<n; j++){                          //2014may06
      fprintf(fp_mat,"%25.17le",mvec[j]);        //2014may06
   }                                             //2014may06
   fprintf(fp_mat,"\n");                         //2014may06
/**********************************************/
//  S * K * S  should not use -O option or good ??
   for(j = 0; j < n ; j++){
      scal = 1.0 / sqrt(mvec[j]);
      for(i=0; i<n; i++){
         a[j*n+i] = scal * a[j*n+i];
         a[i*n+j] = scal * a[i*n+j];
      }
   }
/*** file output A matrix  ***/
   for(i=0; i<n; i++){                           //2014may06
      for (j=0; j<n; j++){                       //2014may06
//       fprintf(fp_mat,"%25.17le",a[n*j+i]);    //2014may06
         if(a[n*j+i] != 0){;  
            fprintf(fp_mat," %d",i);              //2014oct21
            fprintf(fp_mat," %d",j);              //2014oct21
            fprintf(fp_mat,"%25.17le\n",a[n*j+i]); //2014oct21
	 }
      }                                          //2014may06
//    fprintf(fp_mat,"\n");                      //2014may06
   }                                             //2014may06
/**********************************************/
}

//void jacobie(double A[N*N],double tol,int n,int itr[2]){
void jacobev(double *A,double *V,double tol,int n,int itr[2]){
   double v=1000000.0, vmax, t, c, s, akk, all, akj, alj, S;
   int i, j, k, l, m;
   for (j=0; j<n; j++){                  // set I for eigenvectors
      for (i=0; i<n; i++){ V[j*n+i]=0;}
      V[j*n+j]=1;
   }
   for (m=1; m<=itr[0]; m++){
     vmax=0.0; S=0.0;
     for (j=0; j<n; j++){
       for (i=j+1; i<n; i++){
         if (vmax<fabs(A[j*n+i]) && i!=j){ vmax = fabs(A[j*n+i]); k=i; l=j; }
         S += fabs(A[j*n+i]);
       }
     }
     if(m%100 == 0) {printf("iteration=%d S=%e\n", m,S);}
     v=vmax;
     if (S<tol) return;
     if (A[k*n+k]==A[l*n+l]) t=pi/4.0;
     else t=atan(2.*A[l*n+k]/(A[k*n+k]-A[l*n+l]))/2.0;
     c=cos(t); s=sin(t);
     akk=A[k*n+k]*c*c+A[l*n+l]*s*s+2.0*A[l*n+k]*c*s;
     all=A[k*n+k]*s*s+A[l*n+l]*c*c-2.0*A[l*n+k]*c*s;
     A[k*n+k]=akk; A[l*n+k]=0.; A[k*n+l]=0.; A[l*n+l]=all;
     for (j=0; j<n; j++){
       if (j!=k && j!=l){
         akj=A[j*n+k]*c+A[j*n+l]*s;
         alj=-s*A[j*n+k]+c*A[j*n+l];
         A[l*n+j]=alj; A[j*n+l]=alj; A[j*n+k]=akj; A[k*n+j]=akj; }
     }
     for (j=0; j<n; j++){                  // accumulate transformations
         akj=V[k*n+j]*c+V[l*n+j]*s;
         alj=-s*V[k*n+j]+c*V[l*n+j];
         V[k*n+j]=akj; V[l*n+j]=alj;
     }
     itr[1]=m;
   }
   if (m>itr[0]) printf("non-convergence\n");
   return;
 }

void bsort(double * x, int n, int * ind){
    int i, j, k;
    double temp;

    for (i = 0; i < n; i++) {ind[i]=i;}

    for (i = 0; i < n - 1; i++) {
        for (j = n - 1; j > i; j--) {
            if (x[j - 1] > x[j]) {  /* O̗vf̕傫 */
                temp = x[j]; x[j] = x[j - 1]; x[j - 1]= temp;
                k  = ind[j]; ind[j]=ind[j-1]; ind[j - 1] = k;
            }
        }	
    }
}

